/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSOpenGLView;

import dstep.appkit.NSOpenGL;
import dstep.appkit.NSView;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSOpenGLView : NSView
{
	mixin (ObjcWrap);

	static NSOpenGLPixelFormat defaultPixelFormat ()
	{
		return invokeObjcSelfClass!(NSOpenGLPixelFormat, "defaultPixelFormat");
	}

	NSOpenGLView initWithFrame (NSRect frameRect, NSOpenGLPixelFormat format)
	{
		id result = invokeObjcSelf!(id, "initWithFrame:pixelFormat:", NSRect, NSOpenGLPixelFormat)(frameRect, format);
		return result is this.objcObject ? this : (result !is null ? new NSOpenGLView(result) : null);
	}

	this (NSRect frameRect, NSOpenGLPixelFormat format)
	{
		super(NSOpenGLView.alloc.initWithFrame(frameRect, format).objcObject);
	}

	void setOpenGLContext (NSOpenGLContext context)
	{
		return invokeObjcSelf!(void, "setOpenGLContext:", NSOpenGLContext)(context);
	}

	NSOpenGLContext openGLContext ()
	{
		return invokeObjcSelf!(NSOpenGLContext, "openGLContext");
	}

	void clearGLContext ()
	{
		return invokeObjcSelf!(void, "clearGLContext");
	}

	void update ()
	{
		return invokeObjcSelf!(void, "update");
	}

	void reshape ()
	{
		return invokeObjcSelf!(void, "reshape");
	}

	void setPixelFormat (NSOpenGLPixelFormat pixelFormat)
	{
		return invokeObjcSelf!(void, "setPixelFormat:", NSOpenGLPixelFormat)(pixelFormat);
	}

	NSOpenGLPixelFormat pixelFormat ()
	{
		return invokeObjcSelf!(NSOpenGLPixelFormat, "pixelFormat");
	}

	void prepareOpenGL ()
	{
		return invokeObjcSelf!(void, "prepareOpenGL");
	}
}

