/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGPDFPage;

import dstep.applicationservices.coregraphics.CGAffineTransform;
import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.applicationservices.coregraphics.CGPDFDictionary;
import dstep.applicationservices.coregraphics.CGPDFDocument;

struct CGPDFPage;

alias CGPDFPage* CGPDFPageRef;
alias int CGPDFBox;

enum /*CGPDFBox*/ 
{
	kCGPDFMediaBox = 0,
	kCGPDFCropBox = 1,
	kCGPDFBleedBox = 2,
	kCGPDFTrimBox = 3,
	kCGPDFArtBox = 4
}

extern (C)
{
	CGPDFPageRef CGPDFPageRetain (CGPDFPageRef page);
	void CGPDFPageRelease (CGPDFPageRef page);
	CGPDFDocumentRef CGPDFPageGetDocument (CGPDFPageRef page);
	uint CGPDFPageGetPageNumber (CGPDFPageRef page);
	CGRect CGPDFPageGetBoxRect (CGPDFPageRef page, int box);
	int CGPDFPageGetRotationAngle (CGPDFPageRef page);
	CGAffineTransform CGPDFPageGetDrawingTransform (CGPDFPageRef page, int box, CGRect rect, int rotate, bool preserveAspectRatio);
	CGPDFDictionaryRef CGPDFPageGetDictionary (CGPDFPageRef page);
	uint CGPDFPageGetTypeID ();
}