/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSAtomicStoreCacheNode;

import dstep.coredata.NSEntityDescription;
import dstep.coredata.NSManagedObject;
import dstep.coredata.NSManagedObjectID;
import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSAtomicStoreCacheNode : NSObject
{
	mixin (ObjcWrap);

	NSAtomicStoreCacheNode initWithObjectID (NSManagedObjectID moid)
	{
		id result = invokeObjcSelf!(id, "initWithObjectID:", NSManagedObjectID)(moid);
		return result is this.objcObject ? this : (result !is null ? new NSAtomicStoreCacheNode(result) : null);
	}

	this (NSManagedObjectID moid)
	{
		super(NSAtomicStoreCacheNode.alloc.initWithObjectID(moid).objcObject);
	}

	NSManagedObjectID objectID ()
	{
		return invokeObjcSelf!(NSManagedObjectID, "objectID");
	}

	NSMutableDictionary propertyCache ()
	{
		return invokeObjcSelf!(NSMutableDictionary, "propertyCache");
	}

	void setPropertyCache (NSMutableDictionary propertyCache)
	{
		return invokeObjcSelf!(void, "setPropertyCache:", NSMutableDictionary)(propertyCache);
	}

	Object valueForKey (NSString key)
	{
		return invokeObjcSelf!(Object, "valueForKey:", NSString)(key);
	}

	void setValue (Object value, NSString key)
	{
		return invokeObjcSelf!(void, "setValue:forKey:", Object, NSString)(value, key);
	}
}

