/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.cfnetwork.CFHTTPAuthentication;

//import dstep.Availability;
import dstep.coreservices.cfnetwork.CFHTTPMessage;
import dstep.coreservices.cfnetwork.CFNetworkDefs;
import dstep.corefoundation.CoreFoundation;

struct _CFHTTPAuthentication;

alias _CFHTTPAuthentication* CFHTTPAuthenticationRef;
alias int CFStreamErrorHTTPAuthentication;

extern (C)
{
	extern
	{
		const CFStringRef kCFHTTPAuthenticationUsername;
		const CFStringRef kCFHTTPAuthenticationPassword;
		const CFStringRef kCFHTTPAuthenticationAccountDomain;
	}
}

enum /*CFStreamErrorHTTPAuthentication*/ 
{
	kCFStreamErrorHTTPAuthenticationTypeUnsupported = -1000,
	kCFStreamErrorHTTPAuthenticationBadUserName = -1001,
	kCFStreamErrorHTTPAuthenticationBadPassword = -1002
}

extern (C)
{
	uint CFHTTPAuthenticationGetTypeID ();
	CFHTTPAuthenticationRef CFHTTPAuthenticationCreateFromResponse (CFAllocatorRef alloc, CFHTTPMessageRef response);
	ubyte CFHTTPAuthenticationIsValid (CFHTTPAuthenticationRef auth, CFStreamError* error);
	ubyte CFHTTPAuthenticationAppliesToRequest (CFHTTPAuthenticationRef auth, CFHTTPMessageRef request);
	ubyte CFHTTPAuthenticationRequiresOrderedRequests (CFHTTPAuthenticationRef auth);
	ubyte CFHTTPMessageApplyCredentials (CFHTTPMessageRef request, CFHTTPAuthenticationRef auth, CFStringRef username, CFStringRef password, CFStreamError* error);
	ubyte CFHTTPMessageApplyCredentialDictionary (CFHTTPMessageRef request, CFHTTPAuthenticationRef auth, CFDictionaryRef dict, CFStreamError* error);
	CFStringRef CFHTTPAuthenticationCopyRealm (CFHTTPAuthenticationRef auth);
	CFArrayRef CFHTTPAuthenticationCopyDomains (CFHTTPAuthenticationRef auth);
	CFStringRef CFHTTPAuthenticationCopyMethod (CFHTTPAuthenticationRef auth);
	ubyte CFHTTPAuthenticationRequiresUserNameAndPassword (CFHTTPAuthenticationRef auth);
	ubyte CFHTTPAuthenticationRequiresAccountDomain (CFHTTPAuthenticationRef auth);
}