/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.Foundation;

public:

import dstep.corefoundation.CoreFoundation;
import dstep.foundation.FoundationErrors;
import dstep.foundation.NSAffineTransform;
import dstep.foundation.NSAppleEventDescriptor;
import dstep.foundation.NSAppleEventManager;
import dstep.foundation.NSAppleScript;
import dstep.foundation.NSArchiver;
import dstep.foundation.NSArray;
import dstep.foundation.NSAttributedString;
import dstep.foundation.NSAutoreleasePool;
import dstep.foundation.NSBundle;
import dstep.foundation.NSByteOrder;
import dstep.foundation.NSCalendar;
import dstep.foundation.NSCalendarDate;
import dstep.foundation.NSCharacterSet;
import dstep.foundation.NSClassDescription;
import dstep.foundation.NSCoder;
import dstep.foundation.NSComparisonPredicate;
import dstep.foundation.NSCompoundPredicate;
import dstep.foundation.NSConnection;
import dstep.foundation.NSData;
import dstep.foundation.NSDate;
import dstep.foundation.NSDateFormatter;
import dstep.foundation.NSDecimal;
import dstep.foundation.NSDecimalNumber;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSDistantObject;
import dstep.foundation.NSDistributedLock;
import dstep.foundation.NSDistributedNotificationCenter;
import dstep.foundation.NSEnumerator;
import dstep.foundation.NSError;
import dstep.foundation.NSException;
import dstep.foundation.NSExpression;
import dstep.foundation.NSFileHandle;
import dstep.foundation.NSFileManager;
import dstep.foundation.NSFormatter;
import dstep.foundation.NSGarbageCollector;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSHFSFileTypes;
import dstep.foundation.NSHTTPCookie;
import dstep.foundation.NSHTTPCookieStorage;
import dstep.foundation.NSHashTable;
import dstep.foundation.NSHost;
import dstep.foundation.NSIndexPath;
import dstep.foundation.NSIndexSet;
import dstep.foundation.NSInvocation;
import dstep.foundation.NSJavaSetup;
import dstep.foundation.NSKeyValueCoding;
import dstep.foundation.NSKeyValueObserving;
import dstep.foundation.NSKeyedArchiver;
import dstep.foundation.NSLocale;
import dstep.foundation.NSLock;
import dstep.foundation.NSMapTable;
import dstep.foundation.NSMetadata;
import dstep.foundation.NSMethodSignature;
import dstep.foundation.NSNetServices;
import dstep.foundation.NSNotification;
import dstep.foundation.NSNotificationQueue;
import dstep.foundation.NSNull;
import dstep.foundation.NSNumberFormatter;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.foundation.NSObjectScripting;
import dstep.foundation.NSOperation;
import dstep.foundation.NSPathUtilities;
import dstep.foundation.NSPointerArray;
import dstep.foundation.NSPointerFunctions;
import dstep.foundation.NSPort;
import dstep.foundation.NSPortCoder;
import dstep.foundation.NSPortMessage;
import dstep.foundation.NSPortNameServer;
import dstep.foundation.NSPredicate;
import dstep.foundation.NSProcessInfo;
import dstep.foundation.NSPropertyList;
import dstep.foundation.NSProtocolChecker;
import dstep.foundation.NSProxy;
import dstep.foundation.NSRange;
import dstep.foundation.NSRunLoop;
import dstep.foundation.NSScanner;
import dstep.foundation.NSScriptClassDescription;
import dstep.foundation.NSScriptCoercionHandler;
import dstep.foundation.NSScriptCommand;
import dstep.foundation.NSScriptCommandDescription;
import dstep.foundation.NSScriptExecutionContext;
import dstep.foundation.NSScriptKeyValueCoding;
import dstep.foundation.NSScriptObjectSpecifiers;
import dstep.foundation.NSScriptStandardSuiteCommands;
import dstep.foundation.NSScriptSuiteRegistry;
import dstep.foundation.NSScriptWhoseTests;
import dstep.foundation.NSSet;
import dstep.foundation.NSSortDescriptor;
import dstep.foundation.NSSpellServer;
import dstep.foundation.NSStream;
import dstep.foundation.NSString;
import dstep.foundation.NSTask;
import dstep.foundation.NSThread;
import dstep.foundation.NSTimeZone;
import dstep.foundation.NSTimer;
import dstep.foundation.NSURL;
import dstep.foundation.NSURLAuthenticationChallenge;
import dstep.foundation.NSURLCache;
import dstep.foundation.NSURLConnection;
import dstep.foundation.NSURLCredential;
import dstep.foundation.NSURLCredentialStorage;
import dstep.foundation.NSURLDownload;
import dstep.foundation.NSURLError;
import dstep.foundation.NSURLHandle;
import dstep.foundation.NSURLProtectionSpace;
import dstep.foundation.NSURLProtocol;
import dstep.foundation.NSURLRequest;
import dstep.foundation.NSURLResponse;
import dstep.foundation.NSUndoManager;
import dstep.foundation.NSUserDefaults;
import dstep.foundation.NSValue;
import dstep.foundation.NSValueTransformer;
import dstep.foundation.NSXMLDTD;
import dstep.foundation.NSXMLDTDNode;
import dstep.foundation.NSXMLDocument;
import dstep.foundation.NSXMLElement;
import dstep.foundation.NSXMLNode;
import dstep.foundation.NSXMLNodeOptions;
import dstep.foundation.NSXMLParser;
import dstep.foundation.NSZone;