/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSAutoreleasePool;

import dstep.foundation.NSDebug;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSAutoreleasePool : NSObject
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static void addObject (Object anObject)
	{
		return invokeObjcSuperClass!(void, "addObject:", Object)(anObject);
	}

	void addObject (Object anObject)
	{
		return invokeObjcSelf!(void, "addObject:", Object)(anObject);
	}

	void drain ()
	{
		return invokeObjcSelf!(void, "drain");
	}
	
	// NSAutoreleasePoolDebugging
	static void enableRelease (bool enable)
	{
		return invokeObjcSuperClass!(void, "enableRelease:", bool)(enable);
	}

	static void showPools ()
	{
		return invokeObjcSuperClass!(void, "showPools");
	}

	static void resetTotalAutoreleasedObjects ()
	{
		return invokeObjcSuperClass!(void, "resetTotalAutoreleasedObjects");
	}

	static NSUInteger totalAutoreleasedObjects ()
	{
		return invokeObjcSuperClass!(NSUInteger, "totalAutoreleasedObjects");
	}

	static void enableFreedObjectCheck (bool enable)
	{
		return invokeObjcSuperClass!(void, "enableFreedObjectCheck:", bool)(enable);
	}

	static NSUInteger autoreleasedObjectCount ()
	{
		return invokeObjcSuperClass!(NSUInteger, "autoreleasedObjectCount");
	}

	static NSUInteger topAutoreleasePoolCount ()
	{
		return invokeObjcSuperClass!(NSUInteger, "topAutoreleasePoolCount");
	}

	static NSUInteger poolCountHighWaterMark ()
	{
		return invokeObjcSuperClass!(NSUInteger, "poolCountHighWaterMark");
	}

	static void setPoolCountHighWaterMark (NSUInteger count)
	{
		return invokeObjcSuperClass!(void, "setPoolCountHighWaterMark:", NSUInteger)(count);
	}

	static NSUInteger poolCountHighWaterResolution ()
	{
		return invokeObjcSuperClass!(NSUInteger, "poolCountHighWaterResolution");
	}

	static void setPoolCountHighWaterResolution (NSUInteger res)
	{
		return invokeObjcSuperClass!(void, "setPoolCountHighWaterResolution:", NSUInteger)(res);
	}
}

