/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CAScrollLayer;

import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CALayer;

import bindings = dstep.quartzcore.CAScrollLayer_bindings;

private
{
	NSString kCAScrollNone_;
	NSString kCAScrollVertically_;
	NSString kCAScrollHorizontally_;
	NSString kCAScrollBoth_;
}

NSString kCAScrollNone ()
{
	if (kCAScrollNone_)
		return kCAScrollNone_;

	return kCAScrollNone_ = new NSString(bindings.kCAScrollNone);
}

NSString kCAScrollVertically ()
{
	if (kCAScrollVertically_)
		return kCAScrollVertically_;

	return kCAScrollVertically_ = new NSString(bindings.kCAScrollVertically);
}

NSString kCAScrollHorizontally ()
{
	if (kCAScrollHorizontally_)
		return kCAScrollHorizontally_;

	return kCAScrollHorizontally_ = new NSString(bindings.kCAScrollHorizontally);
}

NSString kCAScrollBoth ()
{
	if (kCAScrollBoth_)
		return kCAScrollBoth_;

	return kCAScrollBoth_ = new NSString(bindings.kCAScrollBoth);
}

class CAScrollLayer : CALayer
{
	mixin (ObjcWrap);

	void scrollToPoint (CGPoint p)
	{
		return invokeObjcSelf!(void, "scrollToPoint:", CGPoint)(p);
	}

	void scrollToRect (CGRect r)
	{
		return invokeObjcSelf!(void, "scrollToRect:", CGRect)(r);
	}
}

const TCALayerScrolling = `

	void scrollPoint (CGPoint p)
	{
		return invokeObjcSelf!(void, "scrollPoint:", CGPoint)(p);
	}

	void scrollRectToVisible (CGRect r)
	{
		return invokeObjcSelf!(void, "scrollRectToVisible:", CGRect)(r);
	}

	CGRect visibleRect ()
	{
		return invokeObjcSelf!(CGRect, "visibleRect");
	}

	//mixin ObjcBindMethod!(scrollPoint, "scrollPoint:");
	//mixin ObjcBindMethod!(scrollRectToVisible, "scrollRectToVisible:");
	//mixin ObjcBindMethod!(visibleRect, "visibleRect");

`;

