/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.cssmkrspi;

import dstep.security.cssmtype;
import dstep.security.cssmkrapi;

struct CSSM_SPI_KR_FUNCS
{
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_CC_HANDLE KRRegistrationContextHandle,
						     /*const*/ CSSM_CONTEXT* KRRegistrationContext,
						     /*const*/ CSSM_DATA* KRInData,
						     /*const*/ CSSM_ACCESS_CREDENTIALS* AccessCredentials,
						     CSSM_KR_POLICY_FLAGS KRFlags,
						     int* EstimatedTime,
						     CSSM_HANDLE_PTR ReferenceHandle) RegistrationRequest;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_HANDLE ReferenceHandle,
						     int* EstimatedTime,
						     CSSM_KR_PROFILE_PTR KRProfile) RegistrationRetrieve;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_CC_HANDLE KREnablementContextHandle,
						     /*const*/ CSSM_CONTEXT* KREnablementContext,
						     CSSM_CC_HANDLE CryptoContextHandle,
						     /*const*/ CSSM_CONTEXT* CryptoContext,
						     /*const*/ CSSM_DATA* KRSPOptions,
						     CSSM_KR_POLICY_FLAGS KRFlags,
						     CSSM_DATA_PTR KRFields) GenerateRecoveryFields;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_CC_HANDLE KREnablementContextHandle,
						     /*const*/ CSSM_CONTEXT* KREnablementContext,
						     CSSM_CC_HANDLE CryptoContextHandle,
						     /*const*/ CSSM_CONTEXT* CryptoContext,
						     /*const*/ CSSM_DATA* KRSPOptions,
						     CSSM_KR_POLICY_FLAGS KRFlags,
						     /*const*/ CSSM_DATA* KRFields) ProcessRecoveryFields;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_CC_HANDLE KRRequestContextHandle,
						     /*const*/ CSSM_CONTEXT* KRRequestContext,
						     /*const*/ CSSM_DATA* KRInData,
						     /*const*/ CSSM_ACCESS_CREDENTIALS* AccessCredentials,
						     int* EstimatedTime,
						     CSSM_HANDLE_PTR ReferenceHandle) RecoveryRequest;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_HANDLE ReferenceHandle,
						     int* EstimatedTime,
						     CSSM_HANDLE_PTR CacheHandle,
						     uint* NumberOfRecoveredKeys) RecoveryRetrieve;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_HANDLE CacheHandle,
						     uint IndexInResults,
						     CSSM_CSP_HANDLE CSPHandle,
						     /*const*/ CSSM_RESOURCE_CONTROL_CONTEXT* CredAndAclEntry,
						     uint Flags,
						     CSSM_KEY_PTR RecoveredKey,
						     CSSM_DATA_PTR OtherInfo) GetRecoveredObject;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
							 CSSM_HANDLE ResultsHandle) RecoveryRequestAbort;
	
	extern (C) int function (CSSM_KRSP_HANDLE KRSPHandle,
						     CSSM_CC_HANDLE KeyRecoveryContextHandle,
						     /*const*/ CSSM_CONTEXT* KeyRecoveryContext,
						     CSSM_CC_HANDLE CryptoContextHandle,
						     /*const*/ CSSM_CONTEXT* CryptoContext,
						     uint PassThroughId,
						     /*const*/ void* InputParams,
						     void* *OutputParams) PassThrough;
}

alias CSSM_SPI_KR_FUNCS* CSSM_SPI_KR_FUNCS_PTR;